Xapian: API Documentation: Xapian::ValueCountMatchSpy Class Reference

xapian-core 1.4.30

Classes | Public Member Functions | List of all members
Xapian::ValueCountMatchSpy Class Reference

Class for counting the frequencies of values in the matching documents. More...

`#include <matchspy.h>`

Inheritance diagram for Xapian::ValueCountMatchSpy:
[legend]

## Public Member Functions
| ValueCountMatchSpy ()
| Construct an empty ValueCountMatchSpy.
| ValueCountMatchSpy (Xapian::valueno slot_)
| Construct a MatchSpy which counts the values in a particular slot.
size_t | get_total () const
| Return the total number of documents tallied.
TermIterator | values_begin () const
| Get an iterator over the values seen in the slot.
TermIterator | values_end () const
| End iterator corresponding to values_begin()
TermIterator | top_values_begin (size_t maxvalues) const
| Get an iterator over the most frequent values seen in the slot.
TermIterator | top_values_end (size_t) const
| End iterator corresponding to top_values_begin()
void | operator() (const Xapian::Document &doc, double wt)
| Implementation of virtual operator().
virtual MatchSpy * | clone () const
| Clone the match spy.
virtual std::string | name () const
| Return the name of this match spy.
virtual std::string | serialise () const
| Return this object's parameters serialised as a single string.
virtual MatchSpy * | unserialise (const std::string &serialised, const Registry &context) const
| Unserialise parameters.
virtual std::string | serialise_results () const
| Serialise the results of this match spy.
virtual void | merge_results (const std::string &serialised)
| Unserialise some results, and merge them into this matchspy.
virtual std::string | get_description () const
| Return a string describing this object.
Public Member Functions inherited from Xapian::MatchSpy
| MatchSpy ()
| Default constructor, needed by subclass constructors.
virtual | ~MatchSpy ()
| Virtual destructor, because we have virtual methods.
MatchSpy * | release ()
| Start reference counting this object.
const MatchSpy * | release () const
| Start reference counting this object.

## Detailed Description

Class for counting the frequencies of values in the matching documents.

## Member Function Documentation

## ◆ clone()

virtual MatchSpy * Xapian::ValueCountMatchSpy::clone | ( |  | ) | const
| virtual

Clone the match spy.

The clone should inherit the configuration of the parent, but need not inherit the state. ie, the clone does not need to be passed information about the results seen by the parent.

If you don't want to support the remote backend in your match spy, you can use the default implementation which simply throws Xapian::UnimplementedError.

Note that the returned object will be deallocated by Xapian after use with "delete". If you want to handle the deletion in a special way (for example when wrapping the Xapian API for use from another language) then you can define a static `operator delete` method in your subclass as shown here: https://trac.xapian.org/ticket/554#comment:1

Reimplemented from Xapian::MatchSpy.

## ◆ get_description()

virtual std::string Xapian::ValueCountMatchSpy::get_description | ( |  | ) | const
| virtual

Return a string describing this object.

This default implementation returns a generic answer, to avoid forcing those deriving their own MatchSpy subclasses from having to implement this (they may not care what get_description() gives for their subclass).

Reimplemented from Xapian::MatchSpy.

## ◆ merge_results()

virtual void Xapian::ValueCountMatchSpy::merge_results | ( | const std::string & | serialised | ) |
| virtual

Unserialise some results, and merge them into this matchspy.

The order in which results are merged should not be significant, since this order is not specified (and will vary depending on the speed of the search in each sub-database).

If you don't want to support the remote backend in your match spy, you can use the default implementation which simply throws Xapian::UnimplementedError.

Parameters

  serialised | A string containing the serialised results.

Reimplemented from Xapian::MatchSpy.

## ◆ name()

virtual std::string Xapian::ValueCountMatchSpy::name | ( |  | ) | const
| virtual

Return the name of this match spy.

This name is used by the remote backend. It is passed with the serialised parameters to the remote server so that it knows which class to create.

Return the full namespace-qualified name of your class here - if your class is called MyApp::FooMatchSpy, return "MyApp::FooMatchSpy" from this method.

If you don't want to support the remote backend in your match spy, you can use the default implementation which simply throws Xapian::UnimplementedError.

Reimplemented from Xapian::MatchSpy.

## ◆ operator()()

void Xapian::ValueCountMatchSpy::operator() | ( | const Xapian::Document & | doc,
|  | double | wt
| ) |  |
| virtual

Implementation of virtual operator().

This implementation tallies values for a matching document.

Parameters

  doc | The document to tally values for.
  wt | The weight of the document (ignored by this class).

Implements Xapian::MatchSpy.

## ◆ serialise()

virtual std::string Xapian::ValueCountMatchSpy::serialise | ( |  | ) | const
| virtual

Return this object's parameters serialised as a single string.

If you don't want to support the remote backend in your match spy, you can use the default implementation which simply throws Xapian::UnimplementedError.

Reimplemented from Xapian::MatchSpy.

## ◆ serialise_results()

virtual std::string Xapian::ValueCountMatchSpy::serialise_results | ( |  | ) | const
| virtual

Serialise the results of this match spy.

If you don't want to support the remote backend in your match spy, you can use the default implementation which simply throws Xapian::UnimplementedError.

Reimplemented from Xapian::MatchSpy.

## ◆ top_values_begin()

TermIterator Xapian::ValueCountMatchSpy::top_values_begin | ( | size_t | maxvalues | ) | const

Get an iterator over the most frequent values seen in the slot.

Items will be returned in descending order of frequency. Values with the same frequency will be returned in ascending alphabetical order.

During the iteration, the frequency of the current value can be obtained with the get_termfreq() method on the iterator.

Parameters

  maxvalues | The maximum number of values to return.

## ◆ unserialise()

virtual MatchSpy * Xapian::ValueCountMatchSpy::unserialise | ( | const std::string & | serialised,
|  | const Registry & | context
| ) |  | const
| virtual

Unserialise parameters.

This method unserialises parameters serialised by the serialise() method and allocates and returns a new object initialised with them.

If you don't want to support the remote backend in your match spy, you can use the default implementation which simply throws Xapian::UnimplementedError.

Note that the returned object will be deallocated by Xapian after use with "delete". If you want to handle the deletion in a special way (for example when wrapping the Xapian API for use from another language) then you can define a static `operator delete` method in your subclass as shown here: https://trac.xapian.org/ticket/554#comment:1

Parameters

  serialised | A string containing the serialised results.
  context | Registry object to use for unserialisation to permit MatchSpy subclasses with sub-MatchSpy objects to be implemented.

Reimplemented from Xapian::MatchSpy.

## ◆ values_begin()

TermIterator Xapian::ValueCountMatchSpy::values_begin | ( |  | ) | const

Get an iterator over the values seen in the slot.

Items will be returned in ascending alphabetical order.

During the iteration, the frequency of the current value can be obtained with the get_termfreq() method on the iterator.

The documentation for this class was generated from the following file:

- xapian/matchspy.h